set cformat %7.3f // often ignired, simple fix to simplify the output
	
* 2 satasets needed to be sp-'d: CT census tracts and US census tracts with counties marked
*	https://www.atsdr.cdc.gov/placeandhealth/svi/documentation/SVI_documentation_2018.html 
* * * 	A. Data considerations		;
* download BOTH shape and actual data files: SHAPE will be processed in GeoDa and QGIS

* * * 	B. Shape files manipulations in QGIS & generating spatial lags and Moran's Is in Geoda 		;
* BRING from GeoDa lag components (lgXXX) for FIPS  both COUNTY and CsTr=census tracts  

* ct_829tracts.zip ct_829tracts.dbf + ct_829tracts.shp + ct_829tracts.shx
*	Merging SVI data into the SHAPE file can be done in GeoDA or later in Stata 
* need to create counters within counties, state for pointed analyses or descriptives
bys state (county fipsstr): gen cnstrinstate= _n 
bys state (county fipsstr): gen totcnstrinstate = _N 
lab var cnstrinstate "count of census tracts within state"
lab var totcnstrinstate "total of census tracts within state"

bys stateupper county (fipsstr): gen cnstrincnty= _n 
bys stateupper county (fipsstr): gen totcnstrincnty = _N 
lab var cnstrincnty "count of census tracts within county"
lab var totcnstrincnty "total of census tracts within county"

* keep fipsstr fipsnr statenr cnstrincnty cnstrinstate lfex1015ct lglfexct lgpnhschct e_minrty18ct lgpminoct inck18ct lginckct ep_pov18ct lgppovct ep_unemp18ct lgpunemct e_nohsdp18ct spl_theme118ct spl_theme218ct spl_theme318ct spl_theme418ct spl_themes18ct 
save SVI2018_US_censustracts_AND_county_65963_few.dta


* WHY CT
sum lfex1015ct 
list if statenr==9 & 
list if 

* WHY Spatial
* GENERIC pwcorr Y X ,  sig star(.05)
pwcorr fipsnr lfex1015ct ,  sig star(.05) // US census tracts data 
pwcorr fipsnr lfex1015ct  if statenr==9 ,  sig star(.05) // US census tracts data 
* GENERIC reg Y X 
reg lfex1015ct fipsnr if statenr==9 , beta  // US census tracts data 
* GENERIC sem   (Y <- X) if statenr==??? , standardized 
sem   (lfex1015ct <- fipsnr) if statenr==9 , standardized  // US census tracts data 

* GENERIC 
gsem   (lfex1015ct <- fipsnr) if statenr==9 , standardized  // US census tracts data 
* spatial CT alone: the spatial lags can be used as generated in the US map, OR in the CT only map: border  census tracts however will have different spatial lag scores: their neighborsh from the neighboring states are NOT counted in state-wide spatial shape data.
*	US 
reg lfex1015ct fipsnr lglfexct , beta  // US census tracts data 
sem   (lfex1015ct <- fipsnr lglfexct) , standardized  // US census tracts data 
*	CT 
reg lfex1015ct fipsnr lglfexct if statenr==9 , beta  // US census tracts data 
sem   (lfex1015ct <- fipsnr lglfexct) if statenr==9 , standardized  // US census tracts data 
* GENERIC sem   (Y <- X LagY) if statenr==??? , standardized 

* STATES cnstrinstate = count of census tracts within state
*	statenr lfex1015st lglfexp16st 
pwcorr statenr lfex1015st if cnstrinstate == 1,  sig star(.05) // US census tracts data 

*	https://www.atsdr.cdc.gov/placeandhealth/svi/documentation/SVI_documentation_2018.html 
*	Socioeconomic Status: Below Poverty; Unemployed; Income; No High School Diploma

*	Stata sp CT data ct_829tracts.dta
 * svi1_4it svi2_4it svi3_2it svi4_5it sviall_15 
reg trlfex1015 cstr7dnr , beta // -0.182 SIG
reg  trlfex1015 cstr7dnr lglifeexp, beta // -0.030 NS

* caps seen by sem as latents, so:
* ren (EP_POV EP_UNEMP EP_NOHSDP EP_MINRTY) (ep_pov ep_unemp ep_nohsdp ep_minrty)
* ren (SPL_THEME1 SPL_THEME2 SPL_THEME3 SPL_THEME4 SPL_THEMES) (svi1_4it svi2_4it svi3_2it svi4_5it sviall_15 )

*	csstrct10d  trlfex1015 lglifeexp EP_MINRTY lgpminor
*	ep_pov lgppov + ep_unemp lgunemp + inccdcks lgincmks + ep_nohsdp lgnohsch 	+++	ep_minrty lgpminor 
*+	svi1_4it lgsvi1 

* describe the main ingredients and create binaries to parallel maps
* create 2 categories 
*	pmin2c	lgpmin2c lfex2c lglfex2c cstr7dnr lgcstr7d lgpmin2c 
sum trlfex1015 ep_minrty, detail
*	drop  lfex2c pmin2c
egen pmin2c = cut(ep_minrty), at(0,22.1999, 101)
	replace pmin2c=1 if pmin2c >= 20 &  pmin2c != . 
egen lfex2c = cut(trlfex1015), at(0,79.99, 90)
	replace lfex2c=1 if lfex2c >= 79  &  lfex2c != . 

table pmin2c lfex2c, statistic(mean trlfex1015 )
tabstat trlfex1015 if pmin2c==0, by(lfex2c)  stats(n mean sd min max)   col(stat)
tabstat trlfex1015 if pmin2c!=0, by(lfex2c)  stats(n mean sd min max)   col(stat)

tab1 lfex2c pmin2c
* save out for lagging in Geoda
 lab var lgcstr7d "Geoda queen 829 lag of cstr7dnr"
 lab var lgpmin2c "Geoda queen 829 lag of 2 categ pmin2c"
 lab var lglfex2c "Geoda queen 829 lag of 2 categ lfex2c"
*keep csstrct10d  lfex2c pmin2c cstr7dnr

tab   pmin2c lfex2c, row col chi
sum trlfex1015 ep_minrty
list pmin2c ep_minrty if pmin2c== . & ep_minrty != .

*  descriptives
scatter trlfex1015 ep_minrty
sum  trlfex1015 ep_minrty

sem (<-  trlfex1015 ep_minrty ) , nocapslatent  // to look at the means for the same sample

* GENERIC pwcorr Y X ,  sig star(.05)
pwcorr trlfex1015 ep_minrty ,  sig star(.05) // US census tracts data 

* GENERIC reg Y X 
reg trlfex1015 ep_minrty  , beta  // US census tracts data 
* GENERIC Spatial reg Y X 
reg trlfex1015 ep_minrty lglifeexp , beta  // US census tracts data 
* GENERIC sem   (Y <- X) if statenr==??? , standardized 
sem   (trlfex1015  <- ep_minrty )  , nocapslatent standardized  // US census tracts data 
* GENERIC Spatial sem   (Y <- X LagY) if statenr==??? , standardized 
sem   (trlfex1015  <- ep_minrty lglifeexp)  , nocapslatent standardized  // US census tracts data 

*	Stata gsem 

*	+ lfex1015ct lglfexct inck18ct lginckct ep_unemp18ct lgpunemct lgppovct ep_minrty18ct lgpminoct pminrty15_19st ep_pov18ct lgppovct ep_nohsdp18ct lgpnhschct

* 	create a clean SHAPE file for CT: without the 4 water regions; need the3: ct_829tracts.shp ct_829tracts.dbf ct_829tracts.shx 
*	same is needed to delete islands and Alaska for US counties or states
*	Open shape file in QGIS\ drag the xxx.shp file over the canvass\

* better to use the default location 
cd
C:\data
spshape2dta ct_829tracts, replace
*	:
  (importing .shp file)
  (importing .dbf file)
  (creating _ID spatial-unit id)
  (creating _CX coordinate)
  (creating _CY coordinate)

  file ct_829tracts_shp.dta created
  file ct_829tracts.dta     created
* check them out; we will merge our data into ct_829tracts.dta
*   _ID Spatial-unit ID
*   _CX x-coordinate of area centroid
*   _CY y-coordinate of area centroid

** ct_829tracts_shp.dta is a LONG = Vertical file with N times some other n per each region; and a 
*	ct_829tracts.dta has 11 characters STRING id GEOID10 -> need one in our data like that 
* create a subset of Census Tract CT data for merger into shape file ct_829tracts, posting and analyses 
*	keep csstrct11d cstr7dnr lgcstr7d trlfex1015 lglifeexp lfex2c lglfex2c ep_pov lgppov ep_unemp lgunemp inccdcks lgincmks ep_nohsdp lgnohsch 	ep_minrty lgpminor  pmin2c lgpmin2c svi1_4it lgsvi1 svi2_4it lgsvi1 svi3_2it lgsvi1 svi4_5it lgsvi1 sviall_15 lgsviall 
save "C:\data\ct_829tracts_svi.dta"

* IN the newly created SHAPENAME.dta file!!! NOT the original analytic spatial  data!!! 

use "C:\data\ct_829tracts.dta"
spset, clear
spset GEOID10, modify replace
*	string variables not allowed in varlist;
*	GEOID10 is a string variable
destring GEOID10 , gen (trctnr11d) // is already ordered next to it!!!
* now we make sure we have numeric trctnr11d in our data too; run above line then

*	_ID needs to be now replicated in the dta data file!!! IT should be there!!! 
*	gen _ID = _n 
*	 lab var _ID "id created in ct_829tracts_shp file"

spset trctnr11d, modify replace
*	??? data not spset sometimes 

  (_shp.dta file saved)
  (data in memory saved)

      Sp dataset: ct_829tracts.dta
Linked shapefile: ct_829tracts_shp.dta
            Data: Cross sectional
 Spatial-unit ID: _ID (equal to trctnr11d)
     Coordinates: _CX, _CY (planar)

sort trctnr11d	 
merge 1:1 trctnr11d using ct_829tracts_svi.dta
*		Matched                               829  (_merge==3)

save "C:\data\ct_829tracts.dta", replace
file C:\data\ct_829tracts.dta saved
* create a default map 
grmap trlfex1015

* can create several weight matrices; to compare with GeoDa one, we use the 1st
spmatrix create contiguity Wznorm, normalize(row)
spmatrix create contiguity Wzspectr, normalize(spectral)
spmatrix create contiguity Wzminmax, normalize(minmax)

spgenerate lglfexpNorm_sp = Wznorm*trlfex1015 // EMPTY though…  
spgenerate lglfexpSpect_sp = Wzspectr*trlfex1015 // EMPTY though…  
spgenerate lglfexpMnMx_sp = Wzminmax*trlfex1015 // EMPTY though…  

pwcorr trlfex1015 lglifeexp lglfexpNorm_sp lglfexpSpect_sp lglfexpMnMx_sp , sig star(.05)

* GENERIC reg Y X 
reg  trlfex1015 ep_minrty // trlfex1015 lglifeexp  ep_minrty lgpminor 
* GENERIC sem (Y <- X)
reg  trlfex1015 ep_minrty lglifeexp

* GENERIC SP SPATIAL REGRESSION spreg Y X, ml  dvarlag(Wznorm)  ivarlag(Wznorm:X) errorlag(Wznorm) 
spregress trlfex1015 ep_minrty , ml  dvarlag(Wznorm) 
spregress trlfex1015 ep_minrty , ml  dvarlag(Wznorm)  force // 
estat impact 

* GENERIC SPATIAL sem (Y <- X lagY)
sem  (trlfex1015 <- ep_minrty lglifeexp)
sem  (trlfex1015 <- ep_minrty lglfexpNorm_sp)
sem  (trlfex1015 <- ep_minrty lglfexpSpect_sp)
sem  (trlfex1015 <- ep_minrty lglfexpMnMx_sp)

* GENERIC SPATIAL NONRECURSIVE sem (Y <- X lagY) (X <- Y lagX), cov(e.X*e.Y) 
 sem (trlfex1015 <- ep_minrty lglifeexp) (ep_minrty <- trlfex1015 lgpminor), cov(e.ep_minrty*e.trlfex1015) 
 sem (trlfex1015 <- ep_minrty lglifeexp) (ep_minrty <- trlfex1015 lgpminor) 
 estat framework , fitted standardized 
estat gof, stats(all)
 sem (trlfex1015 <- ep_minrty lglifeexp) (ep_minrty <- trlfex1015 lgpminor) , coeflegend
 * add direct and 1 cycle through
nlcom _b[trlfex1015:ep_minrty] + _b[trlfex1015:ep_minrty] * _b[ep_minrty:trlfex1015] *_b[trlfex1015:ep_minrty] 

*ep_pov lgppov ep_unemp lgunemp inccdcks lgincmks ep_nohsdp lgnohsch 	ep_minrty lgpminor 
* first naive/a-spatial-unit FACTOR ANALYSIS sem (LV -> X1 ) (LV -> X2 ) (LV -> X3 ) (LV -> X4 )
 sem (LV  -> ep_pov ) (LV  -> ep_unemp ) (LV  -> inccdcks ) (LV  -> ep_nohsdp ), standardized
 sem (LV  -> ep_pov ) (LV  -> ep_unemp ) (LV  -> inccdcks ) (LV  -> ep_nohsdp )  (LV  -> trlfex1015 ), standardized
 
 * GENERIC SPATIAL FACTOR ANALYSIS sem (LV lagX1 -> X1 ) (LV lagX2 -> X2 ) (LV lagX3 -> X3 ) (LV lagX4 -> X4 )
 sem (LV lgppov -> ep_pov ) (LV lgunemp -> ep_unemp ) (LV lgincmks -> inccdcks ) (LV lgnohsch -> ep_nohsdp ), standardized
 
 sem (LV lgppov -> ep_pov ) (LV lgunemp -> ep_unemp ) (LV lgincmks -> inccdcks ) (LV lgnohsch -> ep_nohsdp )  (LV lglifeexp -> trlfex1015 ), standardized
 
* GENERIC SPATIAL MEDIATION MODEL gsem (Y <- X M lagY)  (M <- X lagM)
*	to get IE and TE:
gsem, coeflegend

nlcom _b[M:X]*_b[Y:M]	// GENERIC 	IE

nlcom _b[Y:X] + _b[M:X]*_b[Y:M]	// GENERIC 	TE

gsem (trlfex1015 <- ep_minrty inccdcks lglifeexp)  (inccdcks <- ep_minrty lgincmks)
*	to get IE and TE:
gsem, coeflegend
*	IE
nlcom _b[inccdcks:ep_minrty]*_b[trlfex1015:inccdcks]
*	TE
nlcom _b[trlfex1015:ep_minrty] + _b[inccdcks:ep_minrty]*_b[trlfex1015:inccdcks]

* GENERIC SPATIAL MULTILEVEL SEM gsem (Y <- M1[countystr] c.X#M2[countystr]  lagY)
 
gsem (trlfex1015 <- M1[countystr] c.ep_minrty#M2[countystr]  lglifeexp)

* for CT with N=8 counties, it has problems; better then multiple-group
destring countystr , gen (countynr)
tab countystr countynr
01 Fairfield
03 Hartford
05 Litchfield
07 Middlesex
09 New Haven
11 New London
13 Tolland
15 Windham

* GENERIC naive MULTI-group SEM sem (Y <- X lagY), group(countynr) ginvariant(none)

sem (trlfex1015 <- ep_minrty ), group(countynr) ginvariant(none) // means(XXX ) var(XXX) 
estimates store unconstrained
sem (trlfex1015 <- ep_minrty ), group(countynr) ginvariant(scoef)  // means(XXX ) var(XXX) 
estimates store constrained
lrtest unconstrained constrained

tabstat inccdcks , by(countynr)  stats(n mean min max) //trlfex1015

* GENERIC SPATIAL MULTI-group SEM sem (Y <- X lagY), group(countynr) ginvariant(none)

sem (trlfex1015 <- ep_minrty lglifeexp), group(countynr) ginvariant(none) // means(XXX ) var(XXX) 
estimates store unconstrained
sem (trlfex1015 <- ep_minrty lglifeexp), group(countynr) ginvariant(scoef)  // means(XXX ) var(XXX) 
estimates store constrained
lrtest unconstrained constrained

* for graphs one may want to center the predictors
sum ep_minrty lglifeexp 

*   ep_minrty |        829    33.87358    27.66614          0        100
*   lglifeexp |        829    79.73019    2.295006      72.75      85.29


gen pminrtyc = ep_minrty-33.87358
gen lglfexpc = lglifeexp-79.73019
lab var pminrtyc "centered ep_minrty"
lab var lglfexpc "centered lglifeexp"
sem (trlfex1015 <- pminrtyc lglfexpc), group(countynr) ginvariant(none) // means(XXX ) var(XXX) 
tabstat ep_minrty , by(countynr)  stats(n mean min max) //trlfex1015

regress trlfex1015 c.ep_minrty##i(1/15).countynr
margins countynr, dydx(ep_minrty) pwcompare

sort ep_minrty
twoway line trlfex1015 ep_minrty if countynr==1, lcolor("50 136 189") ///
|| line trlfex1015 ep_minrty if countynr==3, lcolor("50 136 189*.15") ///
|| line trlfex1015 ep_minrty if countynr==4, lcolor("50 136 189*.3") ///
|| line trlfex1015 ep_minrty if countynr==7, lcolor("50 136 189*.6") ///
|| line trlfex1015 ep_minrty if countynr==9, lcolor("50 136 189*1.5") ///
|| line trlfex1015 ep_minrty if countynr==11, lcolor("50 136 189*3") ///
|| line trlfex1015 ep_minrty if countynr==13, lcolor("50 136 189*3.5") ///
|| line trlfex1015 ep_minrty if countynr==15, lcolor("50 136 189*4")

regress trlfex1015 c.ep_minrty##c.countynr if inrange(countynr, 1, 15) // interaction model with continuous countynr
*	https://www.stata.com/meeting/japan13/abstracts/materials/jp13_rising.pdf
mixed  trlfex1015 ep_minrty || countynr:
estimates store randint
*	??? do schslope

*	estimates store randslope
* county can be extracted from GEOID 
* extract the 3 characters of string starting with 3rd, to the right
 gen countystr =  substr(GEOID10,3,3) 
 
* GENERIC SPATIAL LMM 	mixed Y X1 lagY   || countynr:  //  random intercept 
mixed trlfex1015 ep_minrty lglifeexp   || countynr:  //  random intercept
* GENERIC SPATIAL LMM 	mixed Y X1 lagY   || countynr: X1 , covariance(unstructured) //  random intercept and slope
mixed trlfex1015 ep_minrty lglifeexp   || countynr: ep_minrty , covariance(unstructured) //  random intercept and slope
	
*	4. Illustrate spatial gsem and compare to sp	 

* * * 	4. https://www.stata.com/manuals/sp.pdf		;
*	4.iii. Estimate the spatial correlation between two spatial variables: nonrecursive spatial SEM
*	trlfex1015 lglifeexp	ep_pov lgppov + ep_unemp lgunemp + inccdcks lgincmks + ep_nohsdp lgnohsch 	+++	ep_minrty lgpminor 
*+	svi1_4it lgsvi1 

*	GENERIC sem   (Y  <- X lgY)  (X  <- Y lgX) , cov(e.X*e.Y)  standardized  
gsem   (trlfex1015  <- ep_minrty lglifeexp)  (ep_minrty  <- trlfex1015 lgpminor) , cov(e.trlfex1015*e.ep_minrty) 
gsem   (trlfex1015  <- ep_minrty lglifeexp)  (ep_minrty  <- trlfex1015 lgpminor) //NS: cov(e.trlfex1015*e.ep_minrty) 
sem   (trlfex1015  <- ep_minrty lglifeexp)  (ep_minrty  <- trlfex1015 lgpminor) , standardized //NS: cov(e.trlfex1015*e.ep_minrty) 

* NONRECURSIVE to estimate model implied corr:
estat framework , fitted standardized //-.5576811 

* * * 	5. 	CFAs	; space-blind 1st
drop cstrks
sum tract5dig cstr10ks inck18ct ep_unemp18ct ep_pov18ct ep_nohsdp18ct
*	gen cstr10ks = tract5dig/10000
sem (LV_SVI1b -> inck18ct ep_unemp18ct ep_pov18ct ep_nohsdp18ct ) , standardized 
* for scaling reasons rescale tract5dig
sem (LV_SVI1b ->  inck18ct  ep_unemp18ct ep_pov18ct ep_nohsdp18ct cstr10ks) 
sem (LV_SVI1b ->  inck18ct ep_unemp18ct ep_pov18ct ep_nohsdp18ct ) , standardized 
* CT
sem (LV_SVI1b ->  inck18ct  ep_unemp18ct ep_pov18ct ep_nohsdp18ct tract5dig) if statenr==9 

* * * 			COUNTY US ;
* H:\[...]]\Cnty_SVI_LifeExp/Cnty_LifeExpSVI2018_US.shp	OFF SVI2018_US_COUNTIES_CDC.zip
lfex1015cy	inck18cy lginck18cy punemp18cy lgpunemcy ep_minrty18cy pmin18cy lgpmincy ep_pov18cy lgppov18cy ep_nohsdp18cy lgpnohscy
sum ep_minrty18cy pmin18cy // ep_ more 

* * * 	5.iv 	Multilevel CFA	CsTr\County;

gsem (c.LV_SVI1b#M1[cntynr] ->  inck18ct) (c.LV_SVI1b#M2[cntynr] ->  ep_unemp18ct) (c.LV_SVI1b#M3[cntynr] -> ep_pov18ct) (c.LV_SVI1b#M4[cntynr] -> ep_nohsdp18ct)    // (c.LV_SVI1b#M5[cntynr] -> cstr10ks) 
* stuck at "Fitting fixed-effects model:
Iteration 0:   log likelihood = -970963.51  
Iteration 1:   log likelihood = -970963.51  
Refining starting values: 

